    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * ---------------
    028 * BarPainter.java
    029 * ---------------
    030 * (C) Copyright 2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 19-Jun-2008 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart.renderer.category;
    042
    043import java.awt.Graphics2D;
    044import java.awt.geom.RectangularShape;
    045
    046import org.jfree.ui.RectangleEdge;
    047
    048/**
    049 * The interface for plugin painter for the {@link BarRenderer} class.  When
    050 * developing a class that implements this interface, bear in mind the
    051 * following:
    052 * <ul>
    053 * <li>the <code>equals(Object)</code> method should be overridden;</li>
    054 * <li>instances of the class should be immutable OR implement the
    055 *     <code>PublicCloneable</code> interface, so that a renderer using the
    056 *     painter can be cloned reliably;
    057 * <li>the class should be <code>Serializable</code>, otherwise chart
    058 *     serialization will not be supported.</li>
    059 * </ul>
    060 *
    061 * @since 1.0.11
    062 */
    063public interface BarPainter {
    064
    065    /**
    066     * Paints a single bar on behalf of a renderer.
    067     *
    068     * @param g2  the graphics target.
    069     * @param renderer  the renderer.
    070     * @param row  the row index for the item.
    071     * @param column  the column index for the item.
    072     * @param bar  the bounds for the bar.
    073     * @param base  the base of the bar.
    074     */
    075    public void paintBar(Graphics2D g2, BarRenderer renderer,
    076            int row, int column, RectangularShape bar, RectangleEdge base);
    077
    078    /**
    079     * Paints the shadow for a single bar on behalf of a renderer.
    080     *
    081     * @param g2  the graphics target.
    082     * @param renderer  the renderer.
    083     * @param row  the row index for the item.
    084     * @param column  the column index for the item.
    085     * @param bar  the bounds for the bar.
    086     * @param base  the base of the bar.
    087     * @param pegShadow  peg the shadow to the base of the bar?
    088     */
    089    public void paintBarShadow(Graphics2D g2, BarRenderer renderer,
    090            int row, int column, RectangularShape bar, RectangleEdge base,
    091            boolean pegShadow);
    092
    093}